-- If you use this code please insert my copyrights.
-- (c) 2014 V10 ( http://v10.name ) 

--StorageStack = {}
function StorageStack_new()
  return {first = 0, last = -1, itemnames={}, last_item="", lastany_index=1}
end

function StorageStack_add_item_name(StorageStack, itemname)
  local itemnames = StorageStack.itemnames
  if not itemnames[itemname] then
    itemnames[itemname] = true
    table.insert(itemnames, itemname)
  end
end

function StorageStack_insert(StorageStack, itemname)
  local itemnames = StorageStack.itemnames
  if not itemnames[itemname] then
    itemnames[itemname] = true
    table.insert(itemnames, itemname)
  end

  local _last = StorageStack.last
  local last = StorageStack[_last]
  if last ~= nil and last.itemname == itemname then
    last.count = last.count + 1
    return
  end

  last = _last + 1
  StorageStack.last = last
  StorageStack[last] = {itemname=itemname, count=1}
end

function StorageStack_getback(StorageStack)
  --return __StorageStack_getback(StorageStack, 0)
  local _first = StorageStack.first
  if _first > StorageStack.last then return nil end
  local first = StorageStack[_first]
  if first ~= nil then
    first.count = first.count - 1
    itemname = first.itemname
    StorageStack.last_item = itemname
    if first.count <= 0 then
      StorageStack[_first] = nil        -- to allow garbage collection
      StorageStack.first = _first + 1
    end
    return itemname
  end
  return nil
end

function StorageStack_getlast(StorageStack)
  if StorageStack.last_item ~= "" then
    return StorageStack.last_item
  end
  return nil
end

function StorageStack_getany(StorageStack)
 local nnn = table.maxn(StorageStack.itemnames)
 if nnn == nil or nnn <= 0 then return nil end
 if nnn == 1 then return StorageStack.itemnames[1] end
 
 res = StorageStack.itemnames[StorageStack.lastany_index]
 StorageStack.lastany_index = StorageStack.lastany_index + 1
 if StorageStack.lastany_index > nnn then
   StorageStack.lastany_index = 1
 end
 return res
 --return StorageStack["itemnames"][match.random(nnn)]
end

function StorageStack_return(StorageStack, itemname)
  local _first = StorageStack.first
  local first = StorageStack[_first]
  if first ~= nil and first.itemname == itemname then
    first.count = first.count + 1
    return
  end

  first = _first - 1
  StorageStack.first = first
  StorageStack[first] = {itemname=itemname, count=1}
end

function StorageStack_pushleft (StorageStack, value)
  local first = StorageStack.first - 1
  StorageStack.first = first
  StorageStack[first] = value
end

function StorageStack_pushright (StorageStack, value)
  local last = StorageStack.last + 1
  StorageStack.last = last
  StorageStack[last] = value
end

function StorageStack_popleft (StorageStack)
  local first = StorageStack.first
  if first > StorageStack.last then error("StorageStack is empty") end
  local value = StorageStack[first]
  StorageStack[first] = nil        -- to allow garbage collection
  StorageStack.first = first + 1
  return value
end

function StorageStack_popright (StorageStack)
  local last = StorageStack.last
  if StorageStack.first > last then error("StorageStack is empty") end
  local value = StorageStack[last]
  StorageStack[last] = nil         -- to allow garbage collection
  StorageStack.last = last - 1
  return value
end
