-- If you use this code please insert my copyrights.
-- (c) 2014 V10 ( http://v10.name ) 

require "defines" 
require "beltstorage"

game.oninit(function() OnInit() end)
game.onload(function() OnLoad() end)

BeltStorage_AddEntityName("beltstorage1", DIRECTION_LEFT_TO_RIGHT)
BeltStorage_AddEntityName("beltstorage2", DIRECTION_RIGHT_TO_LEFT)
BeltStorage_AddEntityName("beltstorage3", DIRECTION_UP_TO_DOWN)
BeltStorage_AddEntityName("beltstorage4", DIRECTION_DOWN_TO_UP)

game.onevent(defines.events.ontick, function(event)
  if event.tick%5 == 1 and glob.belt_storages[1] then
    for index, storage in ipairs(glob.belt_storages) do
      if storage.entity.valid then
        BeltStorage_frame(storage, event.tick)
      else
        table.remove(glob.belt_storages, index)
      end
    end
  end
end)

game.onevent(defines.events.onbuiltentity, function(event)
  local index = IsBeltStorage(event.createdentity)
  if index ~= nil then
    BeltStorage_add(BeltStorage_new(event.createdentity, index))
  end
end)

function OnInit()
  if not glob.belt_storages then 
     glob.belt_storages = {}
  else
    for index, storage in ipairs(glob.belt_storages) do
      if storage.entity.valid then
        BeltStorage_on_game_init(storage)
      else
        table.remove(glob.belt_storages, index)
      end
    end
  end
end

function OnLoad()
  OnInit()
end

remote.addinterface("BeltStorage",
{
  AddEntityName = function(name, direction_name)
    if BeltStorageDirectionNames[direction_name] then
      BeltStorage_AddEntityName(name, BeltStorageDirectionNames[direction_name])
      return true
    end
    game.player.print("Cannot find direction name '" .. direction_name .. "'!")
    return false
  end,
  Dump = function()
    for index, storage in ipairs(glob.belt_storages) do
       game.player.print(string.format("Storage #%d (%d, %d)", index, storage.entity.position.x, storage.entity.position.y))
       BeltStorage_Dump(storage)
    end
  end
})
